<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentosInternosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentosInternosERP
 * @subpackage Arrays
 */
class ArrayOfDocumentosInternosERP extends AbstractStructArrayBase
{
    /**
     * The DocumentosInternosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentosInternosERP[]
     */
    public $DocumentosInternosERP;
    /**
     * Constructor method for ArrayOfDocumentosInternosERP
     * @uses ArrayOfDocumentosInternosERP::setDocumentosInternosERP()
     * @param \StructType\DocumentosInternosERP[] $documentosInternosERP
     */
    public function __construct(array $documentosInternosERP = array())
    {
        $this
            ->setDocumentosInternosERP($documentosInternosERP);
    }
    /**
     * Get DocumentosInternosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentosInternosERP[]|null
     */
    public function getDocumentosInternosERP()
    {
        return isset($this->DocumentosInternosERP) ? $this->DocumentosInternosERP : null;
    }
    /**
     * Set DocumentosInternosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosInternosERP[] $documentosInternosERP
     * @return \ArrayType\ArrayOfDocumentosInternosERP
     */
    public function setDocumentosInternosERP(array $documentosInternosERP = array())
    {
        foreach ($documentosInternosERP as $arrayOfDocumentosInternosERPDocumentosInternosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentosInternosERPDocumentosInternosERPItem instanceof \StructType\DocumentosInternosERP) {
                throw new \InvalidArgumentException(sprintf('The DocumentosInternosERP property can only contain items of \StructType\DocumentosInternosERP, "%s" given', is_object($arrayOfDocumentosInternosERPDocumentosInternosERPItem) ? get_class($arrayOfDocumentosInternosERPDocumentosInternosERPItem) : gettype($arrayOfDocumentosInternosERPDocumentosInternosERPItem)), __LINE__);
            }
        }
        if (is_null($documentosInternosERP) || (is_array($documentosInternosERP) && empty($documentosInternosERP))) {
            unset($this->DocumentosInternosERP);
        } else {
            $this->DocumentosInternosERP = $documentosInternosERP;
        }
        return $this;
    }
    /**
     * Add item to DocumentosInternosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosInternosERP $item
     * @return \ArrayType\ArrayOfDocumentosInternosERP
     */
    public function addToDocumentosInternosERP(\StructType\DocumentosInternosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentosInternosERP) {
            throw new \InvalidArgumentException(sprintf('The DocumentosInternosERP property can only contain items of \StructType\DocumentosInternosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentosInternosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentosInternosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentosInternosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentosInternosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentosInternosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentosInternosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentosInternosERP
     */
    public function getAttributeName()
    {
        return 'DocumentosInternosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentosInternosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
